#ifndef PDG_UTIL_H
#define PDG_UTIL_H

#include <omega.h>
#include <pdg.h>

namespace pdg
{

typedef std::vector<Variable_ID> varvector;

std::vector<Global_Var_Decl *> extract_globals(PDG* pdg);
Relation map2relation(pdg::UnionMap * map, 
		      const std::vector<Global_Var_Decl *>& params);
Relation set2relation(pdg::UnionSet * set, 
		      const std::vector<Global_Var_Decl *>& params);

void max_index(Constraint_Handle c, varvector& vv, varvector& params);
std::vector<int> constraint_vector(Constraint_Handle c, 
				      varvector& vv, int geq);

class OUnionSet : public pdg::UnionSet {
public:
    OUnionSet (Relation *s, const std::vector<Global_Var_Decl *>& globals);
    static void register_type();
};

class OUnionMap : public pdg::UnionMap {
public:
    OUnionMap (Relation *s, const std::vector<Global_Var_Decl *>& globals);
    static void register_type();
};

}

#endif
